'-------------------------------------
' Joyas: A match-three pieces game
'

' Character set redefinition
data charset() byte = $00,$18,$68,$44,$2C,$30,$00,$00, ' $06: Rotated square
data           byte = $00,$10,$38,$6C,$38,$10,$00,$00, ' $07: Diamond
data           byte = $00,$7C,$54,$7C,$54,$7C,$00,$00, ' $08: Filled Square
data           byte = $00,$64,$2C,$10,$68,$4C,$00,$00, ' $09: Cross
data           byte = $00,$38,$4C,$5C,$7C,$38,$00,$00, ' $0A: Big ball
data           byte = $00,$5C,$40,$54,$04,$74,$00,$00, ' $0B: Flag?
data           byte = $00,$00,$00,$00,$00,$00,$00,$00, ' $0C: Explosion
data           byte = $7C,$82,$82,$82,$82,$82,$7C,$00, ' $0D: Cursor
data           byte = $00,$00,$00,$00,$00,$08,$08,$00, ' .
data           byte = $00,$02,$04,$08,$10,$20,$40,$00, ' /
data           byte = $00,$1C,$26,$2A,$32,$22,$1C,$00, ' 0
data           byte = $00,$08,$18,$08,$08,$08,$3E,$00, ' 1
data           byte = $00,$1C,$22,$02,$1C,$20,$3E,$00, ' 2
data           byte = $00,$3C,$02,$0C,$02,$02,$3C,$00, ' 3
data           byte = $00,$04,$24,$24,$1E,$04,$04,$00, ' 4
data           byte = $00,$1E,$20,$3C,$02,$02,$3C,$00, ' 5
data           byte = $00,$1C,$20,$3C,$22,$22,$1C,$00, ' 6
data           byte = $00,$1E,$22,$04,$08,$10,$10,$00, ' 7
data           byte = $00,$1C,$22,$1C,$22,$22,$1C,$00, ' 8
data           byte = $00,$1C,$22,$22,$1E,$02,$1C,$00, ' 9
data           byte = $00,$00,$10,$00,$00,$00,$10,$00, ' :
data           byte = $00,$00,$08,$08,$00,$08,$08,$10, ' ;
data           byte = $00,$00,$04,$08,$10,$08,$04,$00, ' <
data           byte = $00,$00,$3E,$00,$3E,$00,$00,$00, ' =
data           byte = $00,$00,$20,$10,$08,$10,$20,$00, ' >
data           byte = $00,$1C,$22,$04,$08,$00,$08,$00, ' ?
data           byte = $00,$00,$20,$70,$20,$00,$00,$00, ' @ : PLUS
data           byte = $00,$1C,$22,$22,$3E,$22,$22,$00, ' A
data           byte = $00,$1C,$22,$3C,$22,$22,$3C,$00, ' B
data           byte = $00,$1E,$20,$20,$20,$20,$1E,$00, ' C
data           byte = $00,$1C,$22,$22,$22,$22,$3C,$00, ' D
data           byte = $00,$1E,$20,$3C,$20,$20,$1E,$00, ' E
data           byte = $00,$1E,$20,$3C,$20,$20,$20,$00, ' F
data           byte = $00,$1C,$22,$20,$26,$22,$1C,$00, ' G
data           byte = $00,$22,$22,$3E,$22,$22,$22,$00, ' H
data           byte = $00,$0E,$38,$08,$08,$08,$3E,$00, ' I
data           byte = $00,$06,$0C,$04,$04,$24,$18,$00, ' J
data           byte = $00,$22,$24,$28,$34,$22,$22,$00, ' K
data           byte = $00,$20,$20,$20,$20,$20,$1E,$00, ' L
data           byte = $00,$36,$49,$49,$49,$49,$41,$00, ' M
data           byte = $00,$1C,$22,$22,$22,$22,$22,$00, ' N
data           byte = $00,$1C,$22,$22,$22,$22,$1C,$00, ' O
data           byte = $00,$1C,$22,$22,$3C,$20,$20,$00, ' P
data           byte = $00,$1C,$22,$22,$22,$2A,$1C,$06, ' Q
data           byte = $00,$1C,$22,$22,$3C,$24,$22,$00, ' R
data           byte = $00,$1C,$20,$1C,$02,$02,$3C,$00, ' S
data           byte = $00,$0E,$38,$08,$08,$08,$08,$00, ' T
data           byte = $00,$22,$22,$22,$22,$22,$1C,$00, ' U
data           byte = $00,$22,$22,$14,$14,$08,$08,$00, ' V
data           byte = $00,$41,$49,$49,$49,$49,$36,$00, ' W
data           byte = $00,$24,$14,$08,$14,$22,$22,$00, ' X
data           byte = $00,$22,$22,$22,$1E,$04,$18,$00, ' Y
data           byte = $00,$38,$04,$08,$10,$20,$1E,$00, ' Z
data           byte = $06,$0E,$06,$06,$06,$66,$3C,$00, ' $3B: "J"
data           byte = $3C,$66,$66,$66,$66,$66,$3C,$00, ' $3C: "O"
data           byte = $66,$66,$66,$66,$3E,$0C,$38,$00, ' $3D: "Y"
data           byte = $3C,$66,$66,$7E,$66,$66,$66,$00, ' $3E: "A"
data           byte = $3C,$66,$60,$3C,$06,$66,$3C,$00  ' $3F: "S"


data borders() byte = $D0,$68,$34,$68,$D0,$68,$34,$68, ' 1: Wall 1
data           byte = $16,$2C,$58,$2C,$16,$2C,$58,$2C, ' 2: Wall 2
data           byte = $D1,$6A,$35,$1B,$0E,$04,$00,$00, ' 3: Bottom-left
data           byte = $11,$AA,$55,$BB,$EE,$44,$00,$00, ' 4: Bottom
data           byte = $16,$AC,$58,$B0,$E0,$40,$00,$00, ' 5: Bottom-right

data           byte = $50,$68,$34,$68,$50,$68,$34,$68, ' 1: Wall 1
data           byte = $14,$2C,$58,$2C,$14,$2C,$58,$2C, ' 2: Wall 2
data           byte = $51,$6A,$35,$1B,$0E,$00,$00,$00, ' 3: Bottom-left
data           byte = $11,$AA,$55,$BB,$EE,$00,$00,$00, ' 4: Bottom
data           byte = $14,$AC,$58,$B0,$E0,$00,$00,$00, ' 5: Bottom-right

data           byte = $54,$40,$54,$40,$54,$40,$54,$40, ' 1: Wall 1
data           byte = $54,$04,$54,$04,$54,$04,$54,$04, ' 2: Wall 2
data           byte = $55,$40,$55,$40,$3F,$00,$00,$00, ' 3: Bottom-left
data           byte = $55,$00,$55,$00,$FF,$00,$00,$00, ' 4: Bottom
data           byte = $54,$04,$54,$04,$F8,$00,$00,$00  ' 5: Bottom-right

data explode() byte = $00,$00,$00,$38,$54,$38,$00,$00,
data           byte = $00,$00,$24,$40,$12,$08,$44,$00,
data           byte = $00,$42,$00,$80,$00,$01,$00,$82,
data           byte = $00,$00,$00,$00,$00,$00,$00,$00

' Our board pieces:
data pieces() byte = $06, $47, $88, $C9, $0A, $4B

' Our empty board and the lower line
data eboard() byte = $40,$81,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$82,$40
data lboard() byte = $40,$83,$84,$84,$84,$84,$84,$84,$84,$84,$84,$84,$85,$40

' The high scores and game names
dim hiScore(9), gtName$(3), gcName$(2)

' Name of game types
gtName$(0) = "moves"
gtName$(1) = "timer"
gtName$(2) = "hard "
' Name of game combination
gcName$(0) = "normal"
gcName$(1) = "clear "
gcName$(2) = "diag  "

' Set graphics mode
graphics 18
' Make first line shorter, center the screen
poke dpeek(560) + 3, 70

' Redefine character set
mset $7C00, 8, 0
move adr(charset), $7C30, 464
move adr(borders), $7C08, 40
poke 756, $7C

' Set colors
if peek($d014) = 1
  ' PAL
  se. 0,3,8
  se. 1,11,10
  se. 2,8,6
  se. 3,14,14
  tdiv = 50
  tblink = 10
else
  ' NTSC
  se. 0,4,8
  se. 1,12,10
  se. 2,9,6
  se. 3,2,14
  tdiv = 60
  tblink = 12
endif

' Memory area for the board
mainBoard = $7000 + 18
fullBoard = $7000 + 16
' Clear board, needed to detect bad moves
mset $7000, 240, 0

set = 0
gType  = 0
gCombo = 0
screen = dpeek(88) + 20
screenBoard = screen + 2
C = mainBoard - screenBoard

' Loop forever
do

  ' Clear board
  for i=0 to 9
    move adr(eboard), fullBoard+i*20, 14
  next i

  ' Clear the screen
  mset screen, 220, 0

  ' Show game info
  pos. 4,1
  print #6, "{|"; chr$($FD); "~"; chr$($7F);
  pos. 0,3
  print #6, "BUTTON:game"; chr$(155)
  print #6, "OPTION:exit"; chr$(155)
  print #6, "SELECT:"; chr$(155)
  print #6, "    "; chr$($a1); chr$($26); chr$($07); chr$($A8); chr$($a2)
  print #6, "    "; chr$($a1); chr$($89); chr$($2A); chr$($0B); chr$($a2)
  print #6, "    "; chr$($a3); chr$($a4); chr$($a4); chr$($a4); chr$($a5)
  pos. 14,1  : print #6, "high"
  pos. 14,4  : print #6, "score"
  pos. 14,7  : print #6, "moves"
  pos. 14,10 : print #6, "time"
  exec pScore
  exec pHiscore

  ' Get button and console key states
  but = strig(0) : cons = peek(53279)
  do

    ' Read joystick button transition
    X = strig(0) : I = (not X) and but : but = X
    ' If button pressed, start game
    if I then exit
    ' Read console keys transitions
    X = peek(53279) : I = cons & (7-X) : cons = X
    ' Start game on START
    if I & 1 then exit
    ' Exit on OPTION
    if I & 4
      gr. 0
      end
    endif
    ' Change graphics set on SELECT
    if I & 2
      set = (set + 1) MOD 9
      gType  = set/3       ' Game Type
      gCombo = (set MOD 3) ' Piece combinations
      ' Change border graphics, print game type and high score
      move adr(borders)+gType*40,$7C08,40
      exec pHiscore
      ' Disable attract mode
      poke 77,0
    endif
  loop

  ' Disable attract mode
  poke 77,0
  ' Draw bottom of board
  move adr(lboard), screen+200, 14
  ' Init game variables
  score = 0     ' Score
  nmoves = 15   ' Remaining moves
  addMove = 2   ' Points to bonus
  crsPos = 0    ' Cursor pos
  firstMove = gCombo = 1 ' First move does not score points in "clear" games
  gtime = 0     ' Game time
  stime = 0


  ' Call game loop
  while nmoves > 0
    exec GameLoop
  wend

  if hiScore(set) < score then hiScore(set) = score

loop

'-------------------------------------
' Move the cursor and wait for play
proc MoveCursor

  ' Enable timer
  stime = stime + TIME

  ' Loop
  repeat
    ' Disable attract mode
    poke 77,0

    ' Show cursor
    poke crsPos+screenBoard, $CD
    P = tBlink + 2

    ' Wait for valid move
    repeat
      ' Check time
      if TIME - stime > tdiv
        stime = stime + tdiv
        inc gtime
        ' Remove one move per second in game type 1 and 2
        if gType
          dec nmoves
        endif
        exec pScore
        if not nmoves then exit
      endif
      ' Blink cursor
      P = P - 1
      if P = tBlink - 3
        poke crsPos+screenBoard, peek(crsPos+mainBoard)
      elif not P
        poke crsPos+screenBoard, $CD
        P = tBlink
      endif

      pause 1
      ' Move cursor
      i = stick(0)
      nxtPos = (i=7) - (i=11) + 20 * ((i=13) - (i=14)) + crsPos
    until nxtPos <> crsPos and peek(nxtPos + mainBoard) & 63 > 5

    ' Remove cursor
    poke crsPos+screenBoard, peek(crsPos+mainBoard)

    ' If button is pressed, return
    if not strig(0) then Exit

    ' Key click
    sound 0, 200, 10, 8
    pause 1
    sound
    ' Move cursor
    crsPos = nxtPos
  until not nmoves

  ' Disable timer
  stime = stime - TIME

endproc


'-------------------------------------
' Make pieces fall in the board
proc FallPieces

  ' Loop until there are holes in the board
  repeat

    endFall = 1

    exec DrawBaord

    ' Search for holes in the board
    for A=mainBoard to mainBoard + 180 step 20
      for P=A to A+9
        if peek(P) & 63 = $0C
          ' If we found a hole, fall pieces!
          i = P
          while i > mainBoard + 19
            poke i, peek(i-20)
            i = i-20
          wend
          ' Store new piece and set A to exit outer loop
          poke i, pieces(rand(6))
          A = mainBoard + 190
          endFall = 0
        endif
      next P
    next A
  until endFall

endproc

'-------------------------------------
' Search matching pieces and remove
proc MatchPieces

  ' Number of matches found
  lsize = 0

  ' Go through each line
  for A = screenBoard to screenBoard + 180 step 20
    ' And through each column
    for X=A to A+9
      P = peek(X)
      ' Test if equal to the next two pieces
      if P = peek(X+1) and P = peek(X+2)
        ' Transform screen pointer to board pointer
        Y = X + C
        ' Clean the three pieces found
        PC = (P & 192) + $0C
        poke Y, PC
        poke Y+1, PC
        poke Y+2, PC
        inc lsize
      endif

      ' Test if equal to the two pieces bellow
      IF P = peek(X + 20) and P = peek(X + 40)
        ' Transform screen pointer to board pointer
        Y = X + C
        ' Clean the three pieces found
        PC = (P & 192) + $0C
        poke Y, PC
        poke Y + 20, PC
        poke Y + 40, PC
        inc lsize
      endif

      if gCombo = 2
        ' Test left diagonal
        if P = peek(X+21) and P = peek(X+42)
          ' Transform screen pointer to board pointer
          Y = X + C
          ' Clean the three pieces found
          PC = (P & 192) + $0C
          poke Y, PC
          poke Y+21, PC
          poke Y+42, PC
          inc lsize
        endif

        ' Test right diagonal
        IF P = peek(X+19) and P = peek(X+38)
          ' Transform screen pointer to board pointer
          Y = X + C
          ' Clean the three pieces found
          PC = (P & 192) + $0C
          poke Y, PC
          poke Y + 19, PC
          poke Y + 38, PC
          inc lsize
        endif
      endif
    next X
  next A

  if lsize and not firstMove
    ' Found a line, add to score and show a little animation
    score = score + lsize * lsize
    exec DrawBaord

    for i = 0 to 3
      sound 1, 80, 0, 10 - i * 3
      ' Set animation frame
      move i*8 + adr(explode), $7C60, 8
      pause 4
    next i

    ' Add moves according to sore in game types 1 and 2
    if gType
      if gCombo > 1
        nmoves = nmoves + (lsize / 2)
      else
        nmoves = nmoves + lsize
      endif
    endif
  endif

  ' Add one move at 16, 32, 64, etc. points
  if score >= addMove
    inc nmoves
    addMove = addMove * 2
  endif

  exec pScore
  sound

endproc

'-------------------------------------
' Print spaces until end of line.
proc pSpaces
  while peek($55) < 19
    put #6, 32
  wend
endproc

'-------------------------------------
' Print current score and moves left
proc pScore
  position 14, 5 : print #6, score;  : exec pSpaces
  position 14, 8 : print #6, nmoves; : exec pSpaces
  position 14,11 : print #6, gtime;  : exec pSpaces
endproc

'-------------------------------------
' Print game mode and high score
proc pHiscore
  pos. 7, 7  : print #6, gtName$(gType);
  pos. 7, 8  : print #6, gcName$(gCombo)
  pos. 14, 2 : print #6, hiScore(set); : exec pSpaces
endproc

'-------------------------------------
' Our main game loop
proc GameLoop

  ' Update number of moves in game type 0 and 2
  if gType <> 1
    dec nmoves
  endif

  ' Loop until no pieces are left to move
  repeat
    exec FallPieces
    exec MatchPieces
  until not lsize

  ' We finished the first move
  firstMove = 0

  ' Game over if no more moves
  if nmoves < 1 then exit

  exec MoveCursor

  ' Perform an exchange
  poke crsPos + mainBoard, peek(nxtPos + screenBoard)
  poke nxtPos + mainBoard, peek(crsPos + screenBoard)
  sound 0, 100, 10, 10
  pause 2
  sound

endproc

proc DrawBaord
  ' Move board to screen
  for I = 0 to 180 step 20
     move fullBoard + I, screen + I, 13
  next i
endproc
